#include "TerrainProgram.hpp"

#include "../Renderer.hpp"

using namespace render::gl::pass;

TerrainProgram::TerrainProgram(const TerrainProgram::options& opts): VoxelProgram(opts) {

    ModelMatrixID = glGetUniformLocation(ProgramID, "Model");
}

TerrainProgram::~TerrainProgram() { }

void TerrainProgram::setup(const glm::mat4& modelMatrix, const glm::vec4& sphereProj, float curvature) {
    setModel(&modelMatrix[0][0]);
    VoxelProgram::setup(sphereProj, curvature);
}
void TerrainProgram::unsetCurvature() {
    VoxelProgram::setup(glm::vec4(0), 0);
}
void TerrainProgram::setup(const glm::mat4& modelMatrix) {
    setModel(&modelMatrix[0][0]);
}

void TerrainProgram::setModel(const GLfloat *matrix) {
    glUniformMatrix4fv(ModelMatrixID, 1, GL_FALSE, matrix);
}
