#pragma once

#include "core/utils/zctx.hpp"
#include "core/utils/io.hpp"
#include "core/net/protocol.hpp"
#include "./Chunk.hpp"
#include "./Area.hpp"

namespace world::server {
class Region;

/// Handle compression and packets io
class Serializer {
public:
    Serializer(const std::string &folderPath);

    const zstd::dict_set &Dicts() const { return dicts; }

    using out = memory::read_buffer;

    out writeCapabilities(uint16_t loadDist, size_t flood) const;

    out writeDict() const;
    out writeRegion(const area_region_ref &, const std::shared_ptr<Region> &) const;
    out writeChunk(const node_chunk_ref &, const std::shared_ptr<Chunk> &) const;
    out writeChunkReset() const;
    out writeEdits(node_ref, const fill_edits &) const;

    out writeTeleport(node_id, const relative_transform &) const;
    out writerMessage(const std::string &) const;

private:
    io::file_content dict_content;
    zstd::dict_set dicts;
    zstd::write_ctx dict_write_ctx;
};

}