#pragma once

#include "core/world/Area.hpp"
#include "core/world/actions.hpp"
#include "core/net/protocol.hpp"
#include "core/queue/sorted_queue.hpp"
#include <queue>

namespace world::server {

/// Network client state
struct client {
    client(size_t a, const std::string& n, node_id e):
        accountId(a), name(n), entityId(e) { }

    size_t accountId;
    std::string name;
    node_id entityId;

    /// List of packet to stream to client
    struct {
        std::queue<world::action::FillShape> edits;
        data::sorted_queue<node_chunk_pos, long, true, net::MAX_PENDING_CHUNK_COUNT, true> chunks;
    } pending;

    struct capabilities {
        bool handleEdits = false;
    } caps;
};

}